﻿function displayMessage(msg)
	inInstance, instanceType = IsInInstance()

	local messageType = "SAY"

	if AnnouncerSay==true then
		--
	elseif inInstance == 1 and instanceType ~= "none" then
		messageType = msgType[instanceType]
	end

	if (AnnouncerRW == true and IsRaidOfficer()==1 and instanceType=="raid") then
		messageType = "RAID_WARNING"
	end
	
	SendChatMessage(msg,messageType)
end

function printMessage(msg)
	print("|cff7f7fff[Conjured Announcer] "..msg)
end

function OnEvent(self, event, ...)
	if event == "VARIABLES_LOADED" then
	
		if AnnouncerState==nil then
			AnnouncerState = true
		end

		if AnnouncerSay==nil then
			AnnouncerSay = true
		end
		if AnnouncerRW==nil then
			AnnouncerRW = false
		end		
		
		if AnnouncerState==true then
			conjuredAnnouncer:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		else
			conjuredAnnouncer:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end
		
		printMessage("Kekku's Conjured Announcer loaded.")
		printMessage("Type /can or /cann for options. Announcer stats is: "..getState(AnnouncerState))
			
		SlashCmdList["FFDCMD"] = SlashCommand;
		SLASH_FFDCMD1 = "/can";
		SLASH_FFDCMD2 = "/cann";
	else
		--5/4 22:51:29.781  SPELL_CREATE,    0x02000000040DD826,"Kozko",0x514,0xF112C576000000F7,"Soul Portal",0x4228,    29893,"Ritual of Souls",0x20
		--5/4 22:43:06.135  SPELL_CAST_START,0x02000000043AD5CB,"Kekku",0x511,0x0000000000000000, nil,         0x80000000,92649,"Cauldron of Battle",0x1
		local timestamp, type, sourceGUID,hideCaster, sourceName, sourceFlags,sourceRaidFlags, destGUID, destName, destFlags,destRaidFlags, spellID, spellName = select(1, ...)
		
		--print (type,spellID,sourceName,destName)
		--printMessage (searchTable)

		if (AnnouncerState == true and (UnitInParty(sourceName) or UnitInRaid(sourceName)) and (type=="SPELL_CREATE" or type=="SPELL_SUMMON" or type=="SPELL_CAST_START") and (GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0) and checkTable[spellID]~=nil) then		
			--printMessage ("**************")
			--printMessage (type,spellID,sourceName,destName)
			
			-- use this for cauldrons, they show up only for SPELL_CAST_START and have null for destName
			if (destName==nil) then
				destName = spellName
			end
			
			message     = ">>> " ..sourceName .. " creates " .. destName.." <<<"
			

			
			if (antispamtable[message]==nil) then
				antispamtable[message] = time()
				displayMessage(message)
			else			
				if (time()-antispamtable[message])>10 then
					antispamtable[message] = time()
					displayMessage(message)
				end
			end
		end
	end
end

function helptxt()
	printMessage(" Kekku's Conjured Announcer. Current state: "..getState(AnnouncerState))
	printMessage(" ")	
	printMessage(" Activeate : /can on")
	printMessage(" Deactivate: /can off")
	printMessage(" Announce on SAY: /can say")
	printMessage(" Announce on group chat: /can group")
	printMessage(" Announce on raid warning: /can rw")
end

function SlashCommand(msg)
	local argc, argv = 0, {}
	gsub(msg, "[^%s]+", function (word) argc=argc+1; argv[argc]=word; end);

	if (argc == 1) then
		if (argv[1] == "help") then
			helptxt()
		elseif (argv[1] == "off") then
			printMessage("Announcer state OFF. Type /can on to activate")
			AnnouncerState = false;		
			conjuredAnnouncer:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		elseif  (argv[1] == "on") then
			printMessage("Announcer state ON. Type /can off to deactivate")
			AnnouncerState = true
			conjuredAnnouncer:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		elseif  (argv[1] == "say") then
			AnnouncerSay = true
			printMessage("Announcer set to SAY.")
		elseif  (argv[1] == "rw") then
			AnnouncerRW = not AnnouncerRW
			printMessage("Announcer using raidwarning: "..getState(AnnouncerRW))
		elseif  (argv[1] == "group") then
			AnnouncerSay = false
			printMessage("Announcer set to GROUP.")			
		end
	else
		helptxt()
	end
end

function getState(cond)
	if cond==true then
		return "ON"	
	else
		return "OFF"
	end
end

	
--67826 jewels
--54711 scrapbot
--44389 Field Repair Bot 110G
--57426 fishfeast
--57301 great feast
--54710 moll-e

--92824 Ritual of Refreshment
--92827 Refreshment Portal
--698   Ritual of Summoning
--29893 Ritual of Souls

--92649 Cauldron of Battle
--92712 Big Cauldron of Battle
--87915 Goblin Barbecue Feast
--87644 Seafood Magnifique Feast
--87643 Broiled Dragon Feast


spellIDS   = {67826,54711,44389,57426,57301,54710,92824,92827,698,29893,92649,92712,87915,87644,87643}
checkTable = {}

for i=1,#spellIDS do checkTable[spellIDS[i]]=1 end

msgType = {}
msgType["pvp"]="BATTLEGROUND"
msgType["arena"]="PARTY"
msgType["party"]="PARTY"
msgType["raid"]="RAID"

antispamtable = {}



conjuredAnnouncer = CreateFrame("Frame")
conjuredAnnouncer:RegisterEvent("VARIABLES_LOADED")
conjuredAnnouncer:SetScript("OnEvent", OnEvent)

